/**
* @@@BUILDINFO@@@ MrConnectTextlineStraight.jsx !Version! Wed Jul 25 2007 15:38:26 GMT+0200
*/
/////////////////////////////////////////////////////////////////////////////////////////////
// Feel free to use / modify this code however you wish. 
// We would be happy if you would make a reference to  
// www.looksgood.de and to generative-systeme.de
//
// Benedikt Gro & Julia Laub
// benedikt@looksgood.de / julia@generative-systeme.de
/////////////////////////////////////////////////////////////////////////////////////////////

#include ./lib/bene.jsx
/////////////////////////////////////////////////////////////////////////////////////////////
var myScriptName = app.activeScript.name;

var myObjectList = new Array;
if (app.documents.length != 0){
	if (app.selection.length != 0){
		for(var myCounter = 0;myCounter < app.selection.length; myCounter++){
			switch (app.selection[myCounter].constructor.name){
				case "TextFrame":
					myObjectList.push(app.selection[myCounter]);
					break;
			}
		}
		if (myObjectList.length != 0){
			//run the thing! call a function			
			myConnectLines(myObjectList);
		}
		else{
			alert ("Please select TextFrame and try again.");
		}
	}
	else{
		alert ("Please select an object and try again.");
	}
}
else{
    alert ("Please open a document, select an object, and try again.");
}

/////////////////////////////////////////////////////////////////////////////////////////////
//functions
function myConnectLines(myObjectList){
	var myDocument = app.activeDocument;
	var myLayer, myCounter, myColor;
	var myBounds, myX1, myY1, myX2, myY2;
	
	//Measurement
	var myOldRulerOrigin = myDocument.viewPreferences.rulerOrigin;
	myDocument.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	//Save the current measurement units.
	var myOldXUnits = myDocument.viewPreferences.horizontalMeasurementUnits;
	var myOldYUnits = myDocument.viewPreferences.verticalMeasurementUnits;
	//Set the measurement units to points.
	myDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	myDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	
	//Get references  the None swatch.		
	var myNoneSwatch = myDocument.swatches.item("None");	
	
	//Create a color (if it does not already exist).	
	myColor = myDocument.colors.item(myScriptName);
	try{
		myColorName = myColor.name;
	}
	catch (myError){
		var myColorArray = new Array(100, 0, 0, 0);
		myColor = myDocument.colors.add({model:ColorModel.process, space: ColorSpace.CMYK, colorValue:myColorArray,name: myScriptName});
	}
	
	//Create a layer to hold the generated lines (if it does not already exist).
	myLayer = myDocument.layers.item(myScriptName);
	try{
		myLayerName = myLayer.name;
	}
	catch (myError){
		myLayer = myDocument.layers.add({name:myScriptName});
	}
	
	
	//Process the objects (here text frames) in the selection.	
	for(myCounter = 0; myCounter < myObjectList.length; myCounter ++){
		//get textframe
		var myNewFrame = myObjectList[myCounter];
		//alert(myObjectList[myCounter].paths[0].pathPoints[0].leftDirection+"  "+myObjectList[myCounter].paths[0].pathPoints[0].rightDirection);
		//get bounding box
		myBounds = myNewFrame.visibleBounds;
		myY1 = myBounds[0];
		myX1 = myBounds[1];
		myY2 = myBounds[2];
		myX2 = myBounds[3];
		//get all lines in the frame
		var myLines = myNewFrame.lines;
		//draw for each textline the lines
		for(myLineCounter = 0; myLineCounter < myLines.length-1; myLineCounter ++){
			var myLine = myLines[myLineCounter];
			var myNextLine = myLines[myLineCounter+1];
			var myTmpY = myLine.baseline;
			var myTmpYNext = myNextLine.baseline;
			var myLineFader = 0.2;
			var myTmpYMid = myTmpY+(Math.abs(myTmpYNext-myTmpY)*myLineFader);
			var myCharacters = myLine.characters;
			//last char in line			
			var myLastchar = myCharacters[myCharacters.length-1].contents;
			var myLastcharX;
			
			//convert ascii to number + catch error of some special indesign chars like Shift + Return
			var myCharNum;
			try{
				myCharNum = myLastchar.charCodeAt(0);
			}
			catch (myError){
				myCharNum = 32;
			}								
			//space = 32, carriage return = 13 
			if (myCharNum == 32 || myCharNum == 13)	{
				myLastcharX = myLine.insertionPoints[-2].horizontalOffset+myLine.insertionPoints[-2].pointSize*0.1;
			} else {
				myLastcharX = myLine.insertionPoints[-2].horizontalOffset+myLine.insertionPoints[-2].pointSize;
			}
		
			//straight line only
			//array for points
			var myPathPoints = new Array;			
			//add a point X/Y
			myPathPoints.push([myLastcharX,myTmpY]);
			myPathPoints.push([myX1,myTmpYNext]);				
			//draw the line
			myDrawPolygon(myPathPoints, 1, 100, myColor, myNoneSwatch, myLayer);
			
		}	
	}	
	
	myDocument.viewPreferences.rulerOrigin = myOldRulerOrigin;
	//Set the measurement units back to their original state.
	myDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	myDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;
	
}

