/**
* @@@BUILDINFO@@@ MrTextlineBack.jsx !Version! Wed Jul 25 2007 16:59:13 GMT+0200
*/
/////////////////////////////////////////////////////////////////////////////////////////////
// Feel free to use / modify this code however you wish. 
// We would be happy if you would make a reference to  
// www.looksgood.de and to generative-systeme.de
//
// Benedikt Groß & Julia Laub
// benedikt@looksgood.de / julia@generative-systeme.de
/////////////////////////////////////////////////////////////////////////////////////////////

#include ./lib/bene.jsx 
//InDesign CS2 JavaScript
//Set to 4.0 scripting object model
app.scriptPreferences.version = 4.0;

/////////////////////////////////////////////////////////////////////////////////////////////
var myScriptName = app.activeScript.name;

var myObjectList = new Array;
if (app.documents.length != 0){
	if (app.selection.length != 0){
		for(var myCounter = 0;myCounter < app.selection.length; myCounter++){
			switch (app.selection[myCounter].constructor.name){
				case "TextFrame":
					myObjectList.push(app.selection[myCounter]);
					break;
			}
		}
		if (myObjectList.length != 0){
			//run the thing! call a function			
			myInterface(myObjectList);
		}
		else{
			alert ("Please select TextFrame and try again.");
		}
	}
	else{
		alert ("Please select an object and try again.");
	}
}
else{
    alert ("Please open a document, select an object, and try again.");
}


/////////////////////////////////////////////////////////////////////////////////////////////
//functions


//interface
function myInterface(){
	//Simple User Interface Example
	var myDialog = app.dialogs.add({name:myScriptName,canCancel:true});
	with(myDialog){
		//Add a dialog column.
		with(dialogColumns.add()){
			staticTexts.add({staticLabel:"stroke weight factor (100% = fontsize)"});	
			staticTexts.add({staticLabel:"baseline offset (in pt)"});		
			staticTexts.add({staticLabel:"fill paragraph gaps"});
		}
		
		//Add a dialog column.
		with(dialogColumns.add()){		
			//Create a number (real) entry field.
			var myInput2 = realEditboxes.add({editValue:75});
			var myInput1 = realEditboxes.add({editValue:0});				
			//Create another border panel.				
			var myRadioButtonGroup = radiobuttonGroups.add();
			with(myRadioButtonGroup){
				var myRadioButton1 = radiobuttonControls.add({staticLabel:" "});					
			}			
		}	
		


	}
	//Display the dialog box.
	var myResult = myDialog.show();
	if(myResult == true){
		
		//Get the values from the dialog box controls.
		//run the thing!
		myLinesSpecial(myObjectList,myInput1.editValue,myInput2.editValue,myRadioButton1.checkedState);
			
		//Remove the dialog box from memory.
		myDialog.destroy();	
	} else{
		//User clicked Cancel, so remove the dialog box from memory.
		myDialog.destroy();
	}
}

//Main thing

function myLinesSpecial(myObjectList,myInput1,myInput2,myRadio1){
	var myDocument = app.activeDocument;
	var myLayer, myCounter, myColor;
	var myBounds, myX1, myY1, myX2, myY2;
	
	//Measurement
	var myOldRulerOrigin = myDocument.viewPreferences.rulerOrigin;
	myDocument.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	//Save the current measurement units.
	var myOldXUnits = myDocument.viewPreferences.horizontalMeasurementUnits;
	var myOldYUnits = myDocument.viewPreferences.verticalMeasurementUnits;
	//Set the measurement units to points.
	myDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	myDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	
	//Get references  the None swatch.		
	var myNoneSwatch = myDocument.swatches.item("None");	
	
	//Create a color (if it does not already exist).	
	myColor = myDocument.colors.item(myScriptName);
	try{
		myColorName = myColor.name;
	}
	catch (myError){
		var myColorArray = new Array(100, 0, 0, 0);
		myColor = myDocument.colors.add({model:ColorModel.process, space: ColorSpace.CMYK, colorValue:myColorArray,name:myScriptName});
	}
	
	//Create a layer to hold the generated lines (if it does not already exist).
	myLayer = myDocument.layers.item(myScriptName);
	try{
		myLayerName = myLayer.name;
	}
	catch (myError){
		myLayer = myDocument.layers.add({name:myScriptName});
	}
	
	
	//Process the objects (here text frames) in the selection.	
	for(myCounter = 0; myCounter < myObjectList.length; myCounter ++){
		var myNewFrame = myObjectList[myCounter];
		//bounding box
		myBounds = myNewFrame.visibleBounds;
		myY1 = myBounds[0];
		myX1 = myBounds[1];
		myY2 = myBounds[2];
		myX2 = myBounds[3];

		//groß oder klein?	
		//get all lines in the frame
		var myParagraph = myNewFrame.paragraphs.item(0);

		var myLines = myNewFrame.lines;
		//alert (myLines.length);
		//draw for each textline the lines
		for(myLineCounter = 0; myLineCounter < myLines.length; myLineCounter ++){
			myLine = myLines[myLineCounter];
			//var myTmpY = myLine.baseline-myInput1;			
			var myStrokeWeight = myLine.insertionPoints[-2].pointSize*myInput2*0.01; 
			var myTmpY = (myLine.baseline-myInput1)-myStrokeWeight*0.5;
			
			var myCharacters = myLine.characters;
			//last char in line			
			var myLastchar = myCharacters[myCharacters.length-1].contents;
			//convert ascii to number + catch error of some special indesign chars like Shift + Return
			var myCharNum;
			try{
				myCharNum = myLastchar.charCodeAt(0);
			}
			catch (myError){
				myCharNum = 32;
			}			
						
			if(myCharacters.length > 1) {								
					//space = 32, carriage return = 13 
					if (myCharNum == 32 || myCharNum == 13)	{
						var t = myLine.insertionPoints[-2].horizontalOffset+myLine.insertionPoints[-2].pointSize*0.2;
						if (t > myX2) t = myX2;
						myDrawLine([myTmpY, myX1, myTmpY, t], myStrokeWeight, 100, myColor, myNoneSwatch, myLayer);
					} else {
						var t = myLine.insertionPoints[-2].horizontalOffset+myLine.insertionPoints[-2].pointSize;
						if (t > myX2) t = myX2;
						myDrawLine([myTmpY, myX1, myTmpY, t], myStrokeWeight, 100, myColor, myNoneSwatch, myLayer);
					}
			}	else {
					//alert("gap");
					if( myRadio1 == true) {
						var t = myLine.insertionPoints[-2].horizontalOffset+myLine.insertionPoints[-2].pointSize*0.2;
						myDrawLine([myTmpY, myX1, myTmpY, t], myStrokeWeight, 100, myColor, myNoneSwatch, myLayer);
					}
			}
		}			
	}

	myDocument.viewPreferences.rulerOrigin = myOldRulerOrigin;
	//Set the measurement units back to their original state.
	myDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	myDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;
	
}