/**
* @@@BUILDINFO@@@ MrWordModuloTint.jsx !Version! Wed Jul 25 2007 16:41:04 GMT+0200
*/
/////////////////////////////////////////////////////////////////////////////////////////////
// Feel free to use / modify this code however you wish. 
// We would be happy if you would make a reference to  
// www.looksgood.de and to generative-systeme.de
//
// Benedikt Gro & Julia Laub
// benedikt@looksgood.de / julia@generative-systeme.de
/////////////////////////////////////////////////////////////////////////////////////////////

#include ./lib/bene.jsx 
//InDesign CS2 JavaScript
//Set to 4.0 scripting object model
app.scriptPreferences.version = 4.0;

/////////////////////////////////////////////////////////////////////////////////////////////
var myScriptName = app.activeScript.name;

var myObjectList = new Array;
if (app.documents.length != 0){
	if (app.selection.length != 0){
		for(var myCounter = 0;myCounter < app.selection.length; myCounter++){
			switch (app.selection[myCounter].constructor.name){
				//allow only textframes
				case "TextFrame":
					myObjectList.push(app.selection[myCounter]);
					break;
			}
		}
		if (myObjectList.length != 0){
			myInterface();
		}
		else{
			alert ("Please select TextFrame and try again.");
		}
	}
	else{
		alert ("Please select an object and try again.");
	}
}
else{
    alert ("Please open a document, select an object, and try again.");
}

/////////////////////////////////////////////////////////////////////////////////////////////
//functions
////////////////////////////////////////////////////////////////////////////////////////////

//interface
function myInterface(){
	//Simple User Interface Example
	var myDialog = app.dialogs.add({name:myScriptName,canCancel:true});
	with(myDialog){
		//Add a dialog column.
		with(dialogColumns.add()){	
			staticTexts.add({staticLabel:"Wordcount Modulo:"});
			staticTexts.add({staticLabel:"Min Tint Value:"});
		}
		//Add a dialog column.
		with(dialogColumns.add()){		
			//Create a number (real) entry field.
			var myInput1 = realEditboxes.add({editValue:9});				
			//Create a number (real) entry field.
			var myInput2 = realEditboxes.add({editValue:5});
		}		
	}
	//Display the dialog box.
	var myResult = myDialog.show();
	if(myResult == true){
		//Get the values from the dialog box controls.
		//run the thing!
		myWordsSpecial(myObjectList,myInput1.editValue,myInput2.editValue)	
		//Remove the dialog box from memory.
		myDialog.destroy();	
	} else{
		//User clicked Cancel, so remove the dialog box from memory.
		myDialog.destroy();
	}
}

//main thing
function myWordsSpecial(myObjectList,myInput1Number,myInput2Number){
	var myDocument = app.activeDocument;
	var myLayer, myCounter, myColor;
	var myBounds, myX1, myY1, myX2, myY2;
	
	//Measurement
	var myOldRulerOrigin = myDocument.viewPreferences.rulerOrigin;
	myDocument.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	//Save the current measurement units.
	var myOldXUnits = myDocument.viewPreferences.horizontalMeasurementUnits;
	var myOldYUnits = myDocument.viewPreferences.verticalMeasurementUnits;
	//Set the measurement units to points.
	myDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	myDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;		

	//Process the objects (here text frames) in the selection.	
	for(myCounter = 0; myCounter < myObjectList.length; myCounter ++){
		//get textframe
		var myNewFrame = myObjectList[myCounter];
		//get all words in the frame
		var myWords = myNewFrame.words;
		for(myWordCounter = 0; myWordCounter < myWords.length; myWordCounter ++){
			myWord = myWords[myWordCounter];			
			//map ranges
			myWord.fillTint = myMapRange(myWordCounter%(myInput1Number-1),0,myInput1Number,myInput2Number,100);			
		}
	}
	myDocument.viewPreferences.rulerOrigin = myOldRulerOrigin;
	//Set the measurement units back to their original state.
	myDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	myDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;
	
}