/**
* @@@BUILDINFO@@@ MrWriteDownCharacterPointsize.jsx !Version! Wed Jul 25 2007 16:18:26 GMT+0200
*/
/////////////////////////////////////////////////////////////////////////////////////////////
// Feel free to use / modify this code however you wish. 
// We would be happy if you would make a reference to  
// www.looksgood.de and to generative-systeme.de
//
// Benedikt Gro & Julia Laub
// benedikt@looksgood.de / julia@generative-systeme.de
/////////////////////////////////////////////////////////////////////////////////////////////

#include ./lib/bene.jsx 
//InDesign CS2 JavaScript
//Set to 4.0 scripting object model
app.scriptPreferences.version = 4.0;

/////////////////////////////////////////////////////////////////////////////////////////////
var myScriptName = app.activeScript.name;

var myObjectList = new Array;
if (app.documents.length != 0){
	if (app.selection.length != 0){
		for(var myCounter = 0;myCounter < app.selection.length; myCounter++){
			switch (app.selection[myCounter].constructor.name){			
				//allow only textframes TextFrame
				case "Text":
				case "TextFrame":
				case "Word":
				case "Line":
				case "Paragraph":
				case "Character":
					myObjectList.push(app.selection[myCounter]);
					break;
			}
		}
		if (myObjectList.length != 0){
			//run the thing! call a function			
			myInterface();			
		}
		else{
			alert ("Please select a TextFrame only or select a Text");
		}
	}
	else{
		alert ("Please select an object and try again.");
	}
}
else{
    alert ("Please open a document, select an object, and try again.");
}

/////////////////////////////////////////////////////////////////////////////////////////////
//functions
////////////////////////////////////////////////////////////////////////////////////////////

//interface
function myInterface(){
	//Simple User Interface Example
	var myDialog = app.dialogs.add({name:myScriptName,canCancel:true});
	with(myDialog){
		//Add a dialog column.
		with(dialogColumns.add()){	
			staticTexts.add({staticLabel:"dezimals for fontsizes below (0.XXX): "});
			staticTexts.add({staticLabel:"dezimals for fontsizes below (0.0XX): "});
			staticTexts.add({staticLabel:"dezimals for fontsizes below (0.00X): "});
			staticTexts.add({staticLabel:" "});
			staticTexts.add({staticLabel:"baseline offset for creates textframes: "});
		}


		//Add a dialog column.
		with(dialogColumns.add()){	
			//Create a number (real) entry field.
			var myInput1 = realEditboxes.add({editValue:30});				
			//Create a number (real) entry field.
			var myInput2 = realEditboxes.add({editValue:45});	
			//Create a number (real) entry field.
			var myInput3 = realEditboxes.add({editValue:65});
			staticTexts.add({staticLabel:" "});				
			//Create a number (real) entry field.
			var myInput4 = realEditboxes.add({editValue:1});
		}
			
	}
	//Display the dialog box.
	var myResult = myDialog.show();
	if(myResult == true){		
		//Get the values from the dialog box controls.
		//run the thing!
		myWordsSpecial(myObjectList,myInput4.editValue,myInput1.editValue,myInput2.editValue,myInput3.editValue)	
		//Remove the dialog box from memory.
		myDialog.destroy();	
	} else{
		//User clicked Cancel, so remove the dialog box from memory.
		myDialog.destroy();
	}
}

//main thing
function myWordsSpecial(myObjectList,theBaselineOffset,theInput1,theInput2,theInput3){
	var myDocument = app.activeDocument;
	var myLayer, myCounter, myColor;
	var myBounds, myX1, myY1, myX2, myY2;
	
	//Measurement
	var myOldRulerOrigin = myDocument.viewPreferences.rulerOrigin;
	myDocument.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	//Save the current measurement units.
	var myOldXUnits = myDocument.viewPreferences.horizontalMeasurementUnits;
	var myOldYUnits = myDocument.viewPreferences.verticalMeasurementUnits;
	//Set the measurement units to points.
	myDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	myDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	
	//Get references the None ParagraphStyle.		
	var myNoneParagraphStyle = myDocument.paragraphStyles.item(0);	
	
	//Create the character style if it does not already exist. 
	myCharacterStyle = myDocument.characterStyles.item(myScriptName); 
	try{ 
		myCharacterStyle.name; 
	} 
	catch (myError){ 
		myCharacterStyle = myDocument.characterStyles.add({name:myScriptName}); 
		myCharacterStyle.pointSize = 5;
	} 

	
	
	//Create a layer to hold the generated lines (if it does not already exist).
	myLayer = myDocument.layers.item(myScriptName);
	try{
		myLayerName = myLayer.name;
	}
	catch (myError){
		myLayer = myDocument.layers.add({name:myScriptName});
	}
	
	//Process the objects (here text frames) in the selection.	
	for(myCounter = 0; myCounter < myObjectList.length; myCounter ++){
		//get page
		//var myPage = myObjectList[myCounter].parent.documentOffset-1;
		//get object
		var myNewFrame = myObjectList[myCounter];
		//get all words in the frame
		var myCharacters = myNewFrame.characters;
		for(myCharacterCounter = 0; myCharacterCounter < myCharacters.length; myCharacterCounter ++){
			var myCharacter = myCharacters[myCharacterCounter];
			//if (myCharacter.contents != " " && myCharacter.contents != "g" && myCharacter.contents != "p" && myCharacter.contents != "y" && myCharacter.contents != "j" && myCharacter.contents != "." && myCharacter.contents != ",") {
			if (myCharacter.contents != " " && myCharacter.contents != "." && myCharacter.contents != ",") {
				//Create a new text frame and assign it to the variable "myTextFrame"
				var myTextFrame = app.activeWindow.activeSpread.textFrames.add(myLayer);
				//Specify the size and shape of the text frame.
				var myTmpY = myCharacter.baseline+theBaselineOffset;
				myTextFrame.geometricBounds = [myTmpY, myCharacter.horizontalOffset, myTmpY+8, myCharacter.horizontalOffset+20];
				//Enter text in the text frame.
				myTextFrame.contents = myRound(myCharacter.pointSize,theInput1,theInput2,theInput3) + "";				
				var myParagraph = myTextFrame.paragraphs.item(0);				
				myParagraph.appliedParagraphStyle = myNoneParagraphStyle;
				myParagraph.appliedCharacterStyle = myCharacterStyle;
				myParagraph.justification = Justification.leftAlign;
			}
		}			
	}
	myDocument.viewPreferences.rulerOrigin = myOldRulerOrigin;
	//Set the measurement units back to their original state.
	myDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	myDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;
	
}